from orchestrator.domain.base import SubscriptionModel
from orchestrator.types import SubscriptionLifecycle, strEnum

from products.product_blocks.device import DeviceBlock, DeviceBlockInactive, DeviceBlockProvisioning


class DeviceType(strEnum):
    router = "router"
    switch= "switch"

class DeviceVendor(strEnum):
    Juniper = "juniper"
    Newvendor= "newvendor"

class DeviceInactive(SubscriptionModel, is_base=True):
    device_type: DeviceType
    device_vendor: DeviceVendor
    device: DeviceBlockInactive


class DeviceProvisioning(DeviceInactive, lifecycle=[SubscriptionLifecycle.PROVISIONING]):
    device_type: DeviceType
    device_vendor: DeviceVendor
    device: DeviceBlockProvisioning


class Device(DeviceProvisioning, lifecycle=[SubscriptionLifecycle.ACTIVE]):
    device_type: DeviceType
    device_vendor: DeviceVendor
    device: DeviceBlock
